<template>
  <div class="col-md-12">
    <div class="card card-container">
      <img
          id="profile-img"
          src="//ssl.gstatic.com/accounts/ui/avatar_2x.png"
          class="profile-img-card"
          alt="profile-img"
      />
      <form name="form" @submit.prevent="handleChangePassword">
        <div class="form-group">
          <label for="oldPassword">Stare hasło</label>
          <input
              id="oldPassword"
              v-model="form.oldPassword"
              v-validate="'required'"
              type="password"
              class="form-control"
              name="oldPassword"
          />
          <div
              v-if="errors.has('oldPassword')"
              class="alert alert-danger"
              role="alert"
          >Musisz podać stare hasło!
          </div>
        </div>
        <div class="form-group">
          <label for="newPassword">Nowe hasło</label>
          <input
              id="newPassword"
              v-model="form.newPassword"
              v-validate="'required|min:6|max:40'"
              type="password"
              class="form-control"
              name="newPassword"
          />
          <div
              v-if="errors.has('newPassword')"
              class="alert alert-danger"
              role="alert"
          >Musisz podać nowe hasło o długości 6-40 znaków!
          </div>
        </div>
        <div class="form-group">
          <button class="btn btn-primary btn-block" :disabled="loading">
            <span v-show="loading" class="spinner-border spinner-border-sm"></span>
            <span>Zmień hasło</span>
          </button>
        </div>
        <div class="form-group">
          <div v-if="message" class="alert alert-danger" role="alert">{{ message }}</div>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import changepasswordobject from "@/models/changepasswordobject";
import ChangePasswordService from '../../services/changepassword.service';
import User from "@/models/user";

export default {
  name: 'Login',
  data() {
    return {
      form: new changepasswordobject('', ''),
      loading: false,
      message: '',
      // eslint-disable-next-line no-undef
      user: new User('', '')
    };
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    },
  },
  mounted() {
    if (!this.currentUser)
      this.$router.push('/login')
  },
  methods: {

    handleChangePassword() {
      if (!this.form.newPassword || !this.form.oldPassword)
        alert('Uzupełnij wszystkie dane!')
      else if (this.form.newPassword || this.form.oldPassword) {

        this.user.username = this.currentUser.username;
        this.user.password = this.form.oldPassword;

        ChangePasswordService.tryLogin(this.user).then(
            response => {
              if (response.status === 200) {
                ChangePasswordService.changePassword(this.form).then(
                    // eslint-disable-next-line no-unused-vars
                    response => {
                      alert('Hasło zmienione poprawnie. Zaloguj się nowym hasłem! :)')
                      this.$store.dispatch('auth/logout');
                      this.$router.push('/login');
                    },
                    // eslint-disable-next-line no-unused-vars
                    error => {}
                )
              }
            },
            error => {
              if (error.response.status === 401)
                alert('Podane stare hasło jest nieprawidłowe! Spróbuj ponownie!')
            }
        )

      }
    }
  }
};
</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}

.card-container.card {
  max-width: 350px !important;
  padding: 40px 40px;
}

.card {
  background-color: #f7f7f7;
  padding: 20px 25px 30px;
  margin: 0 auto 25px;
  margin-top: 50px;
  -moz-border-radius: 2px;
  -webkit-border-radius: 2px;
  border-radius: 2px;
  -moz-box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
  -webkit-box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
  box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
}

.profile-img-card {
  width: 96px;
  height: 96px;
  margin: 0 auto 10px;
  display: block;
  -moz-border-radius: 50%;
  -webkit-border-radius: 50%;
  border-radius: 50%;
}
</style>

<!--              () => {
                ChangePasswordService.changePassword(this.form).then(
                    () => {
                      console.log()
                      this.loading = false;
                      alert('Zmieniono hasło poprawnie! Zaloguj się nowym hasłem')

                      this.$store.dispatch('auth/logout');
                      this.$router.push('/login');
                    }
                )
              },
              error => {
                this.loading = false;
                this.message =
                    (error.response && error.response.data && error.response.data.message) ||
                    error.message ||
                    error.toString();

                if (confirm("Podałeś złe stare hasło, chcesz spróbować jeszcze raz?")) {
                  // eslint-disable-next-line no-unused-vars
                  // this.$forceUpdate()
                  this.$router.push('/changepassword').catch(err => {});
                } else {
                  console.log('sdhsjdhsd')
                  this.$router.push('/profile').catch();
                }
              }-->